// MyExt.cpp

#include "dbgexts.h"

HRESULT CALLBACK 
hellodml(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	UNREFERENCED_PARAMETER(args);

	IDebugControl* pDebugControl;
	if (SUCCEEDED(pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
	{
		pDebugControl->ControlledOutput(DEBUG_OUTCTL_ALL_CLIENTS | DEBUG_OUTCTL_DML, DEBUG_OUTPUT_NORMAL, "<b>Hello</b> <i>DML</i> <u>World!</u>\n");
		pDebugControl->Release();
	}
	return S_OK;
}

HRESULT CALLBACK 
echoasdml(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	IDebugControl* pDebugControl;
	if (SUCCEEDED(pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
	{
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "[Start DML]\n");
		pDebugControl->ControlledOutput(DEBUG_OUTCTL_ALL_CLIENTS | DEBUG_OUTCTL_DML, DEBUG_OUTPUT_NORMAL, "%s\n", args);
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "[End DML]\n");
		pDebugControl->Release();
	}
	return S_OK;
}

HRESULT CALLBACK 
echoasdmlescape(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	IDebugControl* pDebugControl;
	if (SUCCEEDED(pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
	{
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "[Start DML]\n");
		if ((args != NULL) && (strlen(args) > 0))
		{
			char* szEscape = (char*)malloc(strlen(args) * 6);
			if (szEscape == NULL)
			{
				pDebugControl->Release();
				return E_OUTOFMEMORY;
			}
			size_t n=0; size_t e=0;
			for (; n<strlen(args); n++)
			{
				switch (args[n])
				{
				case '&':
					memcpy(&szEscape[e], "&amp;", 5);
					e+=5;
					break;
				case '<':
					memcpy(&szEscape[e], "&lt;", 4);
					e+=4;
					break;
				case '>':
					memcpy(&szEscape[e], "&gt;", 4);
					e+=4;
					break;
				case '"':
					memcpy(&szEscape[e], "&quot;", 6);
					e+=6;
					break;
				default:
					szEscape[e] = args[n];
					e+=1;
					break;
				}
			}
			szEscape[e++] = '\0';
			pDebugControl->ControlledOutput(DEBUG_OUTCTL_ALL_CLIENTS | DEBUG_OUTCTL_DML, DEBUG_OUTPUT_NORMAL, "%s\n", szEscape);
			free(szEscape);
		}
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "[End DML]\n");
		pDebugControl->Release();
	}
	return S_OK;
}
